﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication1
{
    class Point
    {
        protected int x; // member field
        protected int y;
        public int X // property
        {
            get { return x;  }
            set { x = value; }
        }
        public int Y
        {
            get { return y; }
            set { y = value; }
        }

        // ctor
        public Point(): this(10, 10) { }
        public Point(int x, int y) 
        {
            this.x = x;
            this.y = y;
        }

        // method
        public void SetPosition(int x, int y)
        {
            this.x = x;
            this.y = y;
        }

        public void Move(int x, int y)
        {
            this.x += x;
            this.y += y;
        }

        public virtual void Move(Point other)
        {
            this.x += other.X;
            this.y += other.Y;
        }

        public override string ToString()
        {
            return String.Format("({0}, {1})", x, y);
        }

        public virtual void Print()
        {
            Console.WriteLine("({0}, {1})", x, y);
        }
    }
}
